## org.apache.xpath.domapi
Class XPathNamespaceImpl

    java.lang.Object
      org.apache.xpath.domapi.XPathNamespaceImpl

All Implemented Interfaces:
  Node, XPathNamespace

public class XPathNamespaceImpl
extends java.lang.Object
implements XPathNamespace

The `XPathNamespace` interface is returned by `XPathResult` interfaces to represent the XPath namespace node type that DOM lacks. There is no public constructor for this node type. Attempts to place it into a hierarchy or a NamedNodeMap result in a `DOMException` with the code `HIERARCHY_REQUEST_ERR` . This node is read only, so methods or setting of attributes that would mutate the node result in a DOMException with the code `NO_MODIFICATION_ALLOWED_ERR`.

The core specification describes attributes of the `Node` interface that are different for different node node types but does not describe `XPATH_NAMESPACE_NODE`, so here is a description of those attributes for this node type. All attributes of `Node` not described in this section have a `null` or `false` value.

`ownerDocument` matches the `ownerDocument` of the `ownerElement` even if the element is later adopted.

`prefix` is the prefix of the namespace represented by the node.

`nodeName` is the same as `prefix`.

`nodeType` is equal to `XPATH_NAMESPACE_NODE`.

`namespaceURI` is the namespace URI of the namespace represented by the node.

`adoptNode`, `cloneNode`, and `importNode` fail on this node type by raising a `DOMException` with the code `NOT_SUPPORTED_ERR`.In future versions of the XPath specification, the definition of a namespace node may be changed incomatibly, in which case incompatible changes to field values may be required to implement versions beyond XPath 1.0.

See also the Document Object Model (DOM) Level 3 XPath Specification. This implementation wraps the DOM attribute node that contained the namespace declaration.

Usage:
  **Experimental**

Field Summary

Fields inherited from interface org.w3c.dom.xpath.XPathNamespace
`XPATH_NAMESPACE_NODE`

Fields inherited from interface org.w3c.dom.Node
`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

Constructor Summary
`XPathNamespaceImpl(Node node)` Constructor for XPathNamespaceImpl.

Method Summary
`Node` `appendChild(Node arg0)` Adds the node `newChild` to the end of the list of children of this node.
`Node` `cloneNode(boolean arg0)` Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes.
`NamedNodeMap` `getAttributes()` A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.
`NodeList` `getChildNodes()` A `NodeList` that contains all children of this node.
`Node` `getFirstChild()` The first child of this node.
`Node` `getLastChild()` The last child of this node.
`java.lang.String` `getLocalName()` Returns the local part of the qualified name of this node.
`java.lang.String` `getNamespaceURI()` The namespace URI of this node, or `null` if it is unspecified.
`Node` `getNextSibling()` The node immediately following this node.
`java.lang.String` `getNodeName()` The name of this node, depending on its type; see the table above.
`short` `getNodeType()` A code representing the type of the underlying object, as defined above.
`java.lang.String` `getNodeValue()` The value of this node, depending on its type; see the table above.
`Document` `getOwnerDocument()` The `Document` object associated with this node.
`Element` `getOwnerElement()` The `Element` on which the namespace was in scope when it was requested.
`Node` `getParentNode()` The parent of this node.
`java.lang.String` `getPrefix()` The namespace prefix of this node, or `null` if it is unspecified.
`Node` `getPreviousSibling()` The node immediately preceding this node.
`boolean` `hasAttributes()` Returns whether this node (if it is an element) has any attributes.
`boolean` `hasChildNodes()` Returns whether this node has any children.
`Node` `insertBefore(Node arg0, Node arg1)` Inserts the node `newChild` before the existing child node `refChild`.
`boolean` `isSupported(java.lang.String arg0, java.lang.String arg1)` Tests whether the DOM implementation implements a specific feature and that feature is supported by this node.
`void` `normalize()` Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only structure (e.g., elements, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are neither adjacent `Text` nodes nor empty `Text` nodes.
`Node` `removeChild(Node arg0)` Removes the child node indicated by `oldChild` from the list of children, and returns it.
`Node` `replaceChild(Node arg0, Node arg1)` Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.
`void` `setNodeValue(java.lang.String arg0)` The value of this node, depending on its type; see the table above.
`void` `setPrefix(java.lang.String arg0)` The namespace prefix of this node, or `null` if it is unspecified.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### XPathNamespaceImpl

    public XPathNamespaceImpl(Node node)

  Constructor for XPathNamespaceImpl.

Method Detail

### getOwnerElement

    public Element getOwnerElement()

  Description copied from interface: `XPathNamespace`
  The `Element` on which the namespace was in scope when it was requested. This does not change on a returned namespace node even if the document changes such that the namespace goes out of scope on that element and this node is no longer found there by XPath.

  Specified by:
    `getOwnerElement` in interface `XPathNamespace`
  See Also:
    `org.apache.xalan.dom3.xpath.XPathNamespace#getOwnerElement()`

### getNodeName

    public java.lang.String getNodeName()

  Description copied from interface: `Node`
  The name of this node, depending on its type; see the table above.

  Specified by:
    `getNodeName` in interface `Node`
  See Also:
    `Node.getNodeName()`

### getNodeValue

    public java.lang.String getNodeValue()
                                  throws DOMException

  Description copied from interface: `Node`
  The value of this node, depending on its type; see the table above. When it is defined to be `null`, setting it has no effect.

  Specified by:
    `getNodeValue` in interface `Node`
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.
  See Also:
    `Node.getNodeValue()`

### setNodeValue

    public void setNodeValue(java.lang.String arg0)
                      throws DOMException

  Description copied from interface: `Node`
  The value of this node, depending on its type; see the table above. When it is defined to be `null`, setting it has no effect.

  Specified by:
    `setNodeValue` in interface `Node`
  Throws:
    `DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.
  See Also:
    `Node.setNodeValue(String)`

### getNodeType

    public short getNodeType()

  Description copied from interface: `Node`
  A code representing the type of the underlying object, as defined above.

  Specified by:
    `getNodeType` in interface `Node`
  See Also:
    `Node.getNodeType()`

### getParentNode

    public Node getParentNode()

  Description copied from interface: `Node`
  The parent of this node. All nodes, except `Attr`, `Document`, `DocumentFragment`, `Entity`, and `Notation` may have a parent. However, if a node has just been created and not yet added to the tree, or if it has been removed from the tree, this is `null`.

  Specified by:
    `getParentNode` in interface `Node`
  See Also:
    `Node.getParentNode()`

### getChildNodes

    public NodeList getChildNodes()

  Description copied from interface: `Node`
  A `NodeList` that contains all children of this node. If there are no children, this is a `NodeList` containing no nodes.

  Specified by:
    `getChildNodes` in interface `Node`
  See Also:
    `Node.getChildNodes()`

### getFirstChild

    public Node getFirstChild()

  Description copied from interface: `Node`
  The first child of this node. If there is no such node, this returns `null`.

  Specified by:
    `getFirstChild` in interface `Node`
  See Also:
    `Node.getFirstChild()`

### getLastChild

    public Node getLastChild()

  Description copied from interface: `Node`
  The last child of this node. If there is no such node, this returns `null`.

  Specified by:
    `getLastChild` in interface `Node`
  See Also:
    `Node.getLastChild()`

### getPreviousSibling

    public Node getPreviousSibling()

  Description copied from interface: `Node`
  The node immediately preceding this node. If there is no such node, this returns `null`.

  Specified by:
    `getPreviousSibling` in interface `Node`
  See Also:
    `Node.getPreviousSibling()`

### getNextSibling

    public Node getNextSibling()

  Description copied from interface: `Node`
  The node immediately following this node. If there is no such node, this returns `null`.

  Specified by:
    `getNextSibling` in interface `Node`
  See Also:
    `Node.getNextSibling()`

### getAttributes

    public NamedNodeMap getAttributes()

  Description copied from interface: `Node`
  A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.

  Specified by:
    `getAttributes` in interface `Node`
  See Also:
    `Node.getAttributes()`

### getOwnerDocument

    public Document getOwnerDocument()

  Description copied from interface: `Node`
  The `Document` object associated with this node. This is also the `Document` object used to create new nodes. When this node is a `Document` or a `DocumentType` which is not used with any `Document` yet, this is `null`.

  Specified by:
    `getOwnerDocument` in interface `Node`
  See Also:
    `Node.getOwnerDocument()`

### insertBefore

    public Node insertBefore(Node arg0,
                             Node arg1)
                      throws DOMException

  Description copied from interface: `Node`
  Inserts the node `newChild` before the existing child node `refChild`. If `refChild` is `null`, insert `newChild` at the end of the list of children.
  If `newChild` is a `DocumentFragment` object, all of its children are inserted, in the same order, before `refChild`. If the `newChild` is already in the tree, it is first removed.

  Specified by:
    `insertBefore` in interface `Node`
  Parameters:
    `arg0` - The node to insert.
    `arg1` - The reference node, i.e., the node before which the new node must be inserted.
  Returns:
    The node being inserted.
  Throws:
    `DOMException` - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to insert is one of this node's ancestors or this node itself.
    WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly or if the parent of the node being inserted is readonly.
    NOT_FOUND_ERR: Raised if `refChild` is not a child of this node.
  See Also:
    `Node.insertBefore(Node, Node)`

### replaceChild

    public Node replaceChild(Node arg0,
                             Node arg1)
                      throws DOMException

  Description copied from interface: `Node`
  Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.
  If `newChild` is a `DocumentFragment` object, `oldChild` is replaced by all of the `DocumentFragment` children, which are inserted in the same order. If the `newChild` is already in the tree, it is first removed.

  Specified by:
    `replaceChild` in interface `Node`
  Parameters:
    `arg0` - The new node to put in the child list.
    `arg1` - The node being replaced in the list.
  Returns:
    The node replaced.
  Throws:
    `DOMException` - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to put in is one of this node's ancestors or this node itself.
    WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node or the parent of the new node is readonly.
    NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.
  See Also:
    `Node.replaceChild(Node, Node)`

### removeChild

    public Node removeChild(Node arg0)
                     throws DOMException

  Description copied from interface: `Node`
  Removes the child node indicated by `oldChild` from the list of children, and returns it.

  Specified by:
    `removeChild` in interface `Node`
  Parameters:
    `arg0` - The node being removed.
  Returns:
    The node removed.
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.
  See Also:
    `Node.removeChild(Node)`

### appendChild

    public Node appendChild(Node arg0)
                     throws DOMException

  Description copied from interface: `Node`
  Adds the node `newChild` to the end of the list of children of this node. If the `newChild` is already in the tree, it is first removed.

  Specified by:
    `appendChild` in interface `Node`
  Parameters:
    `arg0` - The node to add.If it is a `DocumentFragment` object, the entire contents of the document fragment are moved into the child list of this node
  Returns:
    The node added.
  Throws:
    `DOMException` - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to append is one of this node's ancestors or this node itself.
    WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly or if the previous parent of the node being inserted is readonly.
  See Also:
    `Node.appendChild(Node)`

### hasChildNodes

    public boolean hasChildNodes()

  Description copied from interface: `Node`
  Returns whether this node has any children.

  Specified by:
    `hasChildNodes` in interface `Node`
  Returns:
    `true` if this node has any children, `false` otherwise.
  See Also:
    `Node.hasChildNodes()`

### cloneNode

    public Node cloneNode(boolean arg0)

  Description copied from interface: `Node`
  Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes. The duplicate node has no parent; ( `parentNode` is `null`.).
  Cloning an `Element` copies all attributes and their values, including those generated by the XML processor to represent defaulted attributes, but this method does not copy any text it contains unless it is a deep clone, since the text is contained in a child `Text` node. Cloning an `Attribute` directly, as opposed to be cloned as part of an `Element` cloning operation, returns a specified attribute ( `specified` is `true`). Cloning any other type of node simply returns a copy of this node.
  Note that cloning an immutable subtree results in a mutable copy, but the children of an `EntityReference` clone are readonly . In addition, clones of unspecified `Attr` nodes are specified. And, cloning `Document`, `DocumentType`, `Entity`, and `Notation` nodes is implementation dependent.

  Specified by:
    `cloneNode` in interface `Node`
  Parameters:
    `arg0` - If `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself (and its attributes, if it is an `Element`).
  Returns:
    The duplicate node.
  See Also:
    `Node.cloneNode(boolean)`

### normalize

    public void normalize()

  Description copied from interface: `Node`
  Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only structure (e.g., elements, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are neither adjacent `Text` nodes nor empty `Text` nodes. This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer lookups) that depend on a particular document tree structure are to be used.In cases where the document contains `CDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `Text` nodes and `CDATASection` nodes.

  Specified by:
    `normalize` in interface `Node`
  See Also:
    `Node.normalize()`

### isSupported

    public boolean isSupported(java.lang.String arg0,
                               java.lang.String arg1)

  Description copied from interface: `Node`
  Tests whether the DOM implementation implements a specific feature and that feature is supported by this node.

  Specified by:
    `isSupported` in interface `Node`
  Parameters:
    `arg0` - The name of the feature to test. This is the same name which can be passed to the method `hasFeature` on `DOMImplementation`.
    `arg1` - This is the version number of the feature to test. In Level 2, version 1, this is the string "2.0". If the version is not specified, supporting any version of the feature will cause the method to return `true`.
  Returns:
    Returns `true` if the specified feature is supported on this node, `false` otherwise.
  See Also:
    `Node.isSupported(String, String)`

### getNamespaceURI

    public java.lang.String getNamespaceURI()

  Description copied from interface: `Node`
  The namespace URI of this node, or `null` if it is unspecified.
  This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. It is merely the namespace URI given at creation time.
  For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`.Per the Namespaces in XML Specification an attribute does not inherit its namespace from the element it is attached to. If an attribute is not explicitly given a namespace, it simply has no namespace.

  Specified by:
    `getNamespaceURI` in interface `Node`
  See Also:
    `Node.getNamespaceURI()`

### getPrefix

    public java.lang.String getPrefix()

  Description copied from interface: `Node`
  The namespace prefix of this node, or `null` if it is unspecified.
  Note that setting this attribute, when permitted, changes the `nodeName` attribute, which holds the qualified name, as well as the `tagName` and `name` attributes of the `Element` and `Attr` interfaces, when applicable.
  Note also that changing the prefix of an attribute that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the `namespaceURI` and `localName` do not change.
  For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`.

  Specified by:
    `getPrefix` in interface `Node`
  See Also:
    `Node.getPrefix()`

### setPrefix

    public void setPrefix(java.lang.String arg0)
                   throws DOMException

  Description copied from interface: `Node`
  The namespace prefix of this node, or `null` if it is unspecified.
  Note that setting this attribute, when permitted, changes the `nodeName` attribute, which holds the qualified name, as well as the `tagName` and `name` attributes of the `Element` and `Attr` interfaces, when applicable.
  Note also that changing the prefix of an attribute that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the `namespaceURI` and `localName` do not change.
  For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`.

  Specified by:
    `setPrefix` in interface `Node`
  Throws:
    `DOMException` - INVALID_CHARACTER_ERR: Raised if the specified prefix contains an illegal character, per the XML 1.0 specification .
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    NAMESPACE_ERR: Raised if the specified `prefix` is malformed per the Namespaces in XML specification, if the `namespaceURI` of this node is `null`, if the specified prefix is "xml" and the `namespaceURI` of this node is different from "http://www.w3.org/XML/1998/namespace", if this node is an attribute and the specified prefix is "xmlns" and the `namespaceURI` of this node is different from " http://www.w3.org/2000/xmlns/", or if this node is an attribute and the `qualifiedName` of this node is "xmlns" .
  See Also:
    `Node.setPrefix(String)`

### getLocalName

    public java.lang.String getLocalName()

  Description copied from interface: `Node`
  Returns the local part of the qualified name of this node.
  For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`.

  Specified by:
    `getLocalName` in interface `Node`
  See Also:
    `Node.getLocalName()`

### hasAttributes

    public boolean hasAttributes()

  Description copied from interface: `Node`
  Returns whether this node (if it is an element) has any attributes.

  Specified by:
    `hasAttributes` in interface `Node`
  Returns:
    `true` if this node has any attributes, `false` otherwise.
  See Also:
    `Node.hasAttributes()`

Copyright © 2004 Apache XML Project. All Rights Reserved.